
QGIS Application - Bug report #21250

QGIS 3 Layer Filter error with Unicode field name

2019-02-13 10:30 AM - Heather  Hillers

Status: Open

Priority: High

Assignee:

Category: Vectors

Affected QGIS version:3.5(master) Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 29068

Description

Hello,

If a user has a shape file with a field name that has an Umlaut in it ("EIGENTÜMER") and they make a Filter on that layer

"EIGENTÜMER" = 'MEINFIRMA'  then the attribute table will correctly reflect the filter (with many returns) but no geometries will appear

on the canvas.  Filtering by a field with a normal ASCII name results in normal behavior.  (I have warned the user that field names should

never have unicode in them.)

History

#1 - 2019-02-13 10:59 AM - Giovanni Manghi

- Status changed from Open to Feedback

Please attach sample data.

#2 - 2019-02-13 02:01 PM - Heather  Hillers

- File test.shx added

- File test.prj added

- File test.qpj added

- File test.dbf added

- File test.shp added

Here is a 4 point shapefile with 2 text fields- EIGENTÜM and EIGEN, each having the same text values.  Compare the filter "EIGENTÜM"='APPLE' with the

filter "EIGEN"='APPLE'.

#3 - 2019-02-13 02:04 PM - Giovanni Manghi

- Status changed from Feedback to Open

- Category changed from Map Legend to Vectors

#4 - 2019-02-13 03:20 PM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#5 - 2019-02-13 03:33 PM - Alessandro Pasotti

- Status changed from Open to Feedback

- File Screenshot_20190213_152700.png added

- Resolution set to worksforme
How did you create the filter? From the legend with right+click?

Which encoding did you choose for the layer (see my attachment)?

#6 - 2019-02-13 03:33 PM - Alessandro Pasotti

- Resolution deleted (worksforme)

#7 - 2019-02-13 03:33 PM - Alessandro Pasotti

- Affected QGIS version changed from 3.4.4 to 3.5(master)

#8 - 2019-02-13 03:38 PM - Heather  Hillers

Hi,

Encoding on the Layer is set to System.  I am on Windows 7.  The System Encoding should be latin1.

From the Legend, I right clicked on the layer and added the filter.

I also tested by opening layer properties and adding a Provider Feature Filter in the Source Tab.  The same behavior resulted.

#9 - 2019-02-13 03:40 PM - Heather  Hillers

I tested with the layer encoding explicitly set to latin1 (iso-8859-1), with the same result.

#10 - 2019-02-13 05:02 PM - Alessandro Pasotti

- Priority changed from Normal to High

- Regression? changed from No to Yes

#11 - 2019-02-13 06:17 PM - Alessandro Pasotti

- Assignee deleted (Alessandro Pasotti)

#12 - 2019-02-13 06:18 PM - Giovanni Manghi

Heather  Hillers wrote:

I tested with the layer encoding explicitly set to latin1 (iso-8859-1), with the same result.

does it work as expected on 2.18?

#13 - 2019-02-13 06:22 PM - Alessandro Pasotti

@Giovanni: didn't you notice that I checked the regression flag?

#14 - 2019-02-13 06:26 PM - Giovanni Manghi

Alessandro Pasotti wrote:
@Giovanni: didn't you notice that I checked the regression flag?

nope, here notifications from Redmine arrive hours later than comments/changes are posted.

#15 - 2019-02-15 09:45 AM - Luigi Pirelli

- Assignee set to Luigi Pirelli

#16 - 2019-02-15 06:02 PM - Luigi Pirelli

note: If source file is recoded in utf-8 it does not generate the problem

#17 - 2019-02-17 10:34 AM - Luigi Pirelli

- Assignee deleted (Luigi Pirelli)

I wasn't able to find a fix not where is the problem... on monday I'll try debugging also gdal calls. In the meantime I leave it unassigned if someone is able to

find a solution

#18 - 2019-03-09 04:57 PM - Giovanni Manghi

- Status changed from Feedback to Open

Files

test.qpj 656 Bytes 2019-02-13 Heather  Hillers

test.prj 388 Bytes 2019-02-13 Heather  Hillers

test.shp 212 Bytes 2019-02-13 Heather  Hillers

test.dbf 814 Bytes 2019-02-13 Heather  Hillers

test.shx 132 Bytes 2019-02-13 Heather  Hillers

Screenshot_20190213_152700.png 121 KB 2019-02-13 Alessandro Pasotti
